# FILE: oc.tcl
#
#	OOMMF core
#
# Last modified on: $Date: 1998/06/26 19:34:48 $
# Last modified by: $Author: donahue $
#
# When this version of the Oc extension is selected by the 'package require'
# command, this file is sourced.

# Verify minimum Tcl/Tk support
if {[catch {package require Tcl 8}]} {
    package require Tcl 7.5
}

# CVS 
package provide Oc 1.0.0.0.0.0

# Set up for autoloading of Oc extension commands
set oc(library) [file dirname [info script]]
if { [lsearch -exact $auto_path $oc(library)] == -1 } {
    lappend auto_path $oc(library)
}

# Gain access to other extensions in the OOMMF project
if { [lsearch -exact $auto_path [file dirname $oc(library)]] == -1 } {
    lappend auto_path [file dirname $oc(library)]
}

# Patch any bugs and missing features in old versions of Tcl
regsub {[.]} $tcl_version {} _
source [file join [file dirname [info script]] bug$_.tcl]

# Bring in OOMMF customizations
source [file join [file dirname [info script]] custom.tcl]

# Initialize the Oc_Main class
Oc_Main Initialize

# Process -console argument
set i 0
while {[string length [set arg [lindex $argv $i]]]} {
    switch -exact -- $arg {
        -console {
            set _ [file join [file dirname [info script]] console.tcl]
            if {[file readable $_]} {
                source $_
            } else {
                error "Can't create console: File not readable: $_"
            }
            set argv [lreplace $argv $i $i]
        }
        default {
            incr i
        }
    }
}
unset arg i _

# Load in any local modifications
set local [file join [file dirname [info script]] local oc.tcl]
if {[file isfile $local] && [file readable $local]} {
    uplevel #0 source $local
}
